import { Observable } from 'rxjs';
import { Action, SetStateParam, SetStateReturn } from './models';
export declare abstract class BaseStore<StateType extends object> {
    /** @deprecated Use the `select` method without arguments */
    state$: Observable<StateType>;
    get state(): StateType;
    private isStateInitialized;
    private notInitializedErrorMessage;
    private initializedErrorMessage;
    setInitialState(initialState: StateType): void;
    setState<P extends SetStateParam<StateType>>(stateOrCallback: P, name?: string): SetStateReturn<StateType, P>;
    abstract undo(action: Action): void;
    effect<ProvidedType = void, OriginType extends Observable<ProvidedType> | unknown = Observable<ProvidedType>, ObservableType = OriginType extends Observable<infer A> ? A : never, ReturnType = ProvidedType | ObservableType extends void ? () => void : (observableOrValue: ObservableType | Observable<ObservableType>) => void>(effectFn: (origin$: OriginType) => Observable<unknown>): ReturnType;
    private assertStateIsInitialized;
    private assertStateIsNotInitialized;
    select: {
        (): Observable<StateType>;
        <R>(mapFn: (state: StateType) => R): Observable<R>;
    };
    destroy(): void;
}
