import { BaseStore } from './base-store';
import { Action, ComponentStoreConfig, ComponentStoreLike } from './models';
export declare function configureComponentStores(config: ComponentStoreConfig): void;
export declare class ComponentStore<StateType extends object> extends BaseStore<StateType> implements ComponentStoreLike<StateType> {
    private actionsOnQueue;
    private readonly combinedMetaReducer;
    private reducer;
    private hasUndoExtension;
    private extensions;
    constructor(initialState?: StateType, config?: ComponentStoreConfig);
    setInitialState(initialState: StateType): void;
    private dispatch;
    undo(action: Action): void;
    destroy(): void;
}
export declare function createComponentStore<T extends object>(initialState?: T | undefined, config?: ComponentStoreConfig): ComponentStore<T>;
