import { Observable } from 'rxjs';
import { Action, EffectConfig, HasEffectMetadata } from './models';
declare type DispatchType<T> = T extends {
    dispatch: infer U;
} ? U : true;
declare type ObservableType<DispatchType, OriginalType> = DispatchType extends false ? OriginalType : Action;
declare type EffectType<OT> = Observable<OT>;
export declare function createEffect<C extends EffectConfig, DT extends DispatchType<C>, OT extends ObservableType<DT, OT>, R extends EffectType<OT>>(v: R, config?: C): R & HasEffectMetadata;
export {};
