import { Action, ComponentStoreLike, FeatureStoreConfig } from './models';
import { BaseStore } from './base-store';
export declare class FeatureStore<StateType extends object> extends BaseStore<StateType> implements ComponentStoreLike<StateType> {
    private readonly _featureKey;
    get featureKey(): string;
    private readonly featureId;
    constructor(featureKey: string, initialState: StateType | undefined, config?: FeatureStoreConfig);
    setInitialState(initialState: StateType): void;
    undo(action: Action): void;
    destroy(): void;
}
export declare function createFeatureStore<T extends object>(featureKey: string, initialState: T | undefined, config?: FeatureStoreConfig): FeatureStore<T>;
