import { Observable } from 'rxjs';
import { StateOrCallback } from './models';
export declare class State<StateType extends object> {
    private initialState?;
    private stateSource;
    state$: Observable<StateType>;
    constructor(initialState?: StateType | undefined);
    get(): StateType | undefined;
    set(v: StateType): void;
    patch(stateOrCallback: StateOrCallback<StateType>): void;
    select(): Observable<StateType>;
    select<R>(mapFn: (state: StateType) => R): Observable<R>;
}
