import { Observable } from 'rxjs';
import { Action, Actions, AppState, CombineReducersFn, HasEffectMetadata, MetaReducer, Reducer, ReducerDictionary, StoreConfig, StoreExtension } from './models';
import { State } from './state';
export declare let hasUndoExtension: boolean;
export declare const reducerState: State<{
    featureReducers: ReducerDictionary<AppState>;
    metaReducers: MetaReducer<AppState>[];
    combineReducersFn: CombineReducersFn<AppState>;
}>;
export declare function addMetaReducers(...reducers: MetaReducer<AppState>[]): void;
export declare const actions$: Actions;
export declare const appState: State<AppState>;
export declare function configureStore(config?: Partial<StoreConfig<AppState>>): void;
export declare function addFeature<StateType>(featureKey: string, reducer: Reducer<StateType>, config?: {
    metaReducers?: MetaReducer<StateType>[];
    initialState?: StateType;
}): void;
export declare function removeFeature(featureKey: string): void;
export declare function effect(effect$: Observable<any> & HasEffectMetadata): void;
export declare function effect(effect$: Observable<Action>): void;
export declare function addExtension(extension: StoreExtension): void;
export declare function dispatch(action: Action): void;
