import { Action, AppState, FeatureConfig, Reducer, StoreConfig } from './models';
import { Observable } from 'rxjs';
export declare abstract class Store {
    abstract feature<StateType>(featureKey: string, reducer: Reducer<StateType>, config?: FeatureConfig<StateType>): void;
    abstract dispatch(action: Action): void;
    abstract select<R>(mapFn: (state: AppState) => R): Observable<R>;
    abstract effect(effect: Observable<any>): void;
}
export declare function configureStore<T>(config: Partial<StoreConfig<T>>): Store | never;
