import { Observable, OperatorFunction } from 'rxjs';
import { Action, HasEffectMetadata, MetaReducer, StateOrCallback, StoreExtension } from './models';
export declare function ofType(...allowedTypes: string[]): OperatorFunction<Action, Action>;
export declare function select<T, R>(mapFn: (state: T) => R): import("rxjs").UnaryFunction<Observable<T>, Observable<R>>;
export declare function miniRxError(message: string): never;
export declare function miniRxConsoleError(message: string, err: any): void;
export declare function hasEffectMetaData(param: Observable<Action>): param is Observable<Action> & HasEffectMetadata;
export declare function beautifyActionForLogging(action: Action, state: object): Action;
export declare function calcNewState<T>(state: T, stateOrCallback: StateOrCallback<T>): T;
export declare function combineMetaReducers<T>(metaReducers: MetaReducer<T>[]): MetaReducer<T>;
export declare function sortExtensions<T extends StoreExtension>(extensions: T[]): T[];
